﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using System.Web.Hosting;

namespace DeskTopStateManager
{
    public class DeskTopStateService : IDeskTopStateService
    {
        [DataContract(Name = "DeskTopStateType")]
        public enum DeskTopStateType
        {
            [EnumMember]
            On,     //在席
            [EnumMember]
            Leave,  //離席
            [EnumMember]
            Out,    //外出
            [EnumMember]
            Atend,  //来客中
            [EnumMember]
            DayOff  //休暇
        }

        [DataContract(Name = "DeskTopStateSet")]
        public class DeskTopStateSet
        {
            [DataMember(Name = "ID")]
            public string ID { get; set; }
            [DataMember(Name = "State")]
            public string State { get; set; } 
        }

        //public IEnumerable<DeskTopStateSet> GetState()
        //{
        //    string path = HostingEnvironment.ApplicationPhysicalPath + @"App_Data\DeskTopStates.xml";
        //    IEnumerable<DeskTopStateSet> states = from n in XElement.Load(path).Elements()
        //                                        where n.Element("ID").Value != "" 
        //                                        select new DeskTopStateSet{ID = n.Element("ID").Value , State = n.Element("State").Value};
        //    return states;
        //} 

    public void SetState(string id, DeskTopStateType type)
        {
            //XMLファイルの読み込み
            string xmlPath = HostingEnvironment.ApplicationPhysicalPath + @"App_Data\DeskTopStates.xml";
            XElement rootElement = XElement.Load(xmlPath);
            var targetIDStateElements = from n in rootElement.Elements()
                                        where n.Element("ID").Value == id.ToString()
                                        select n.Element("State");
            bool find = false;
            foreach (XElement stateElement in targetIDStateElements)
            {
                stateElement.SetValue(type);
                find = true;
                break;
            }
            //該当のIDが無ければ追加、あった場合は上で変更済み
            if (!find)
            {
                XElement idElement = new XElement("ID", id.ToString());
                XElement stateElement = new XElement("State", type);
                XElement desktopStateElement = new XElement("DeskTopState");
                desktopStateElement.Add(idElement);
                desktopStateElement.Add(stateElement);
                rootElement.Add(desktopStateElement);
            }
            rootElement.Save(xmlPath);
            IEnumerable<DeskTopStateSet> states = from n in XElement.Load(xmlPath).Elements()
                                                  where n.Element("ID").Value != ""
                                                  select new DeskTopStateSet { ID = n.Element("ID").Value, State = n.Element("State").Value };
            IDeskTopStateReceiver client = OperationContext.Current.GetCallbackChannel<IDeskTopStateReceiver>();
            client.GetState(states); 
            //更新内容をそのまま返す
            //return type;
        } 
    }
}
