﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace DeskTopStateViewer
{
    public partial class MainPage : UserControl
    {
        static EndpointAddress address = new EndpointAddress("http://localhost:50828/DeskTopStateService.svc"); 
        static PollingDuplexHttpBinding binding = new PollingDuplexHttpBinding(PollingDuplexMode.MultipleMessagesPerPoll);
        DeskTopStateService.DeskTopStateServiceClient proxy = new DeskTopStateService.DeskTopStateServiceClient(binding, address);
        public MainPage()
        {
            InitializeComponent();
            //自動生成されたプロキシクラスを生成する
            //DeskTopStateService.DeskTopStateServiceClient proxy = new DeskTopStateService.DeskTopStateServiceClient();
            //非同期呼び出しの結果を受け取るコールバック関数を定義
            //proxy.SetStateCompleted += new EventHandler<DeskTopStateService.SetStateCompletedEventArgs>(proxy_SetStateCompleted);
            //非同期呼び出しの実行、ID「666」は休暇として更新する（非同期結果にDayOffが返ってくる）
            proxy.SetStateAsync("666",DeskTopStateService.DeskTopStateType.DayOff);
            proxy.GetStateReceived += new EventHandler<DeskTopStateService.GetStateReceivedEventArgs>(proxy_GetStateReceived);
            //proxy.GetStateCompleted += new EventHandler<DeskTopStateService.GetStateCompletedEventArgs>(proxy_GetStateCompleted);
            //proxy.GetStateAsync();
        }

        void proxy_GetStateReceived(object sender, DeskTopStateService.GetStateReceivedEventArgs e)
        {
            string result = ""; 
            if (e.Error == null) 
            { 
                foreach (DeskTopStateService.DeskTopStateSet state in e.state) 
                { 
                    result += state.ID + "/" + state.State + Environment.NewLine; 
                } 
            } 
            this.label1.Content = "在席状況一覧：" + Environment.NewLine + result; 
        }

        //void proxy_GetStateCompleted(object sender, DeskTopStateService.GetStateCompletedEventArgs e)
        //{
        //    this.label1.Content = "ログイン件数：" + e.Result.Count;
        //}

        //void proxy_SetStateCompleted(object sender, DeskTopStateService.SetStateCompletedEventArgs e)
        //{
        //    //非同期結果をプレースホルダに書き込み
        //    this.label1.Content = e.Result.ToString();
        //} 
    }
}
